#include <bits/stdc++.h>

using namespace std;

int x[1000005],y[1000005];
int racun(int kx,int ky,int n)
{
    int br=0;
    for(int i=0;i<n;i++)
    {
        br+=abs(kx-x[i])*abs(ky-y[i]);
    }
    return br;
}
int main()
{
    int m;
    cin>>m;
    int minx=INT_MAX,maxx=INT_MIN,miny=INT_MAX,maxy=INT_MIN;
    for(int i=0;i<m;i++)
    {
        cin>>x[i]>>y[i];

        minx=min(minx,x[i]);
        miny=min(miny,y[i]);
        maxx=max(maxx,x[i]);
        maxy=max(maxy,y[i]);
        if(i==0) cout<<0;
        else
        {
            cout<<max(max(max(racun(minx,maxy,i),racun(minx,miny,i)),racun(maxx,maxy,i)),racun(maxx,miny,i))<<endl;
        }
    }
    return 0;
}